def adaptive_quadrature(f,M,rtol,abstol):
    h = diff(M)
    mp = 0.5*( M[:-1]+M[1:] )
    fx = f(M); fm = f(mp)
    trp_loc = h*( fx[:-1]+fx[1:] )/2
    simp_loc= h*( fx[:-1]+4*fm+fx[1:] )/4
    I = sum(simp_loc)
    est_loc = abs(simp_loc - trp_loc)
    err_tot = sum(est_loc)
    if err_tot > rtol*abs(I) and err_tot > abstol:
        refcells = nonzero( est_loc > 0.9*sum(est_loc)
        /size(est_loc) )[0]
        I = adaptive_quadrature(f,
        sort(append(M,mp[refcells])),rtol,abstol)
    return I